<?php
/**
 * Surgical Hospital functions and definitions
 *
 * @package Surgical Hospital
 */

if ( ! defined( 'SURGICAL_HOSPITAL_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'SURGICAL_HOSPITAL_VERSION', '1.0.0' );
}

function surgical_hospital_setup() {

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'surgical-hospital' ),
			'social-menu' => esc_html__('Social Menu', 'surgical-hospital'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'surgical_hospital_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'surgical_hospital_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $surgical_hospital_content_width
 */
function surgical_hospital_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'surgical_hospital_content_width', 640 );
}
add_action( 'after_setup_theme', 'surgical_hospital_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function surgical_hospital_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'surgical-hospital' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'surgical-hospital' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'surgical-hospital' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'surgical-hospital' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'surgical-hospital' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'surgical-hospital' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'surgical-hospital' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'surgical-hospital' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'surgical_hospital_widgets_init' );


function surgical_hospital_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */

function surgical_hospital_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => rawurlencode('Nunito+Sans:opsz,wght@0,6..12,200..1000;1,6..12,200..1000'),
        'display' => 'swap',
    );
    wp_enqueue_style('surgical-hospital-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-5', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-5/css/all.min.css', array(), '5.15.3');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), wp_get_theme()->get('Version'));

    // Main stylesheet
    wp_enqueue_style('surgical-hospital-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Add custom inline styles
    require get_parent_theme_file_path('/custom-style.php');
	wp_add_inline_style('surgical-hospital-style', $surgical_hospital_custom_css);

    // RTL styles if needed
    if (file_exists(get_stylesheet_directory() . '/rtl.css')) {
        wp_style_add_data('surgical-hospital-style', 'rtl', 'replace');
    }

    // Navigation script
    wp_enqueue_script('surgical-hospital-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Custom script
    wp_enqueue_script('surgical-hospital-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'surgical_hospital_scripts');

if (!function_exists('surgical_hospital_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function surgical_hospital_related_post($post_id){        
        $surgical_hospital_categories = get_the_category($post_id);
        if ($surgical_hospital_categories) {
            $surgical_hospital_category_ids = array();
            $surgical_hospital_category = get_category($surgical_hospital_category_ids);
            $surgical_hospital_categories = get_the_category($post_id);
            foreach ($surgical_hospital_categories as $surgical_hospital_category) {
                $surgical_hospital_category_ids[] = $surgical_hospital_category->term_id;
            }
            $surgical_hospital_count = $surgical_hospital_category->category_count;
            if ($surgical_hospital_count > 1) { ?>

         	<?php
		$surgical_hospital_related_post_wrap = absint(get_theme_mod('surgical_hospital_enable_related_post', 1));
		if($surgical_hospital_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('surgical_hospital_related_post_text', __('Related Post', 'surgical-hospital'))); ?></h2>
                    <?php
                    $surgical_hospital_cat_post_args = array(
                        'category__in' => $surgical_hospital_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'surgical_hospital_related_post_count', '3' ),
                        'post_status' => 'publish',
                        'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $surgical_hospital_featured_query = new WP_Query($surgical_hospital_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($surgical_hospital_featured_query->have_posts()) :

                        while ($surgical_hospital_featured_query->have_posts()) : $surgical_hospital_featured_query->the_post();
                            ?>
                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php surgical_hospital_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $surgical_hospital_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/slider.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $surgical_hospital_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        surgical_hospital_posted_on();
                                        surgical_hospital_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('surgical_hospital_related_posts', 'surgical_hospital_related_post', 10, 1);

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$surgical_hospital_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function surgical_hospital_sanitize_checkbox($surgical_hospital_checked)
{
    // Boolean check.
    return ((isset($surgical_hospital_checked) && true == $surgical_hospital_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';
}

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function surgical_hospital_enqueue_assets() {
	
    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/surgical_hospital_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/surgical_hospital_config_file.php';

	define('SURGICAL_HOSPITAL_FREE_SUPPORT',__('https://wordpress.org/support/theme/surgical-hospital/','surgical-hospital'));
	define('SURGICAL_HOSPITAL_PRO_SUPPORT',__('https://www.revolutionwp.com/support/revolution-wp/','surgical-hospital'));
	define('SURGICAL_HOSPITAL_REVIEW',__('https://wordpress.org/support/theme/surgical-hospital/reviews/','surgical-hospital'));
	define('SURGICAL_HOSPITAL_BUY_NOW',__('https://www.revolutionwp.com/products/hospital-wordpress-theme','surgical-hospital'));
	define('SURGICAL_HOSPITAL_LIVE_DEMO',__('https://demo.revolutionwp.com/surgical-hospital-pro/','surgical-hospital'));
	define('SURGICAL_HOSPITAL_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/surgical-hospital-pro/','surgical-hospital'));
	define('SURGICAL_HOSPITAL_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/surgical-hospital-free/','surgical-hospital'));

}
add_action( 'after_setup_theme', 'surgical_hospital_enqueue_assets' );

function surgical_hospital_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'surgical_hospital_remove_customize_register', 11 );

/************************************************************************************/

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'surgical_hospital_loop_columns');

if (!function_exists('surgical_hospital_loop_columns')) {

	function surgical_hospital_loop_columns() {

		$surgical_hospital_columns = get_theme_mod( 'surgical_hospital_per_columns', 3 );

		return $surgical_hospital_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'surgical_hospital_per_page', 20 );

function surgical_hospital_per_page( $surgical_hospital_cols ) {

  	$surgical_hospital_cols = get_theme_mod( 'surgical_hospital_product_per_page', 9 );

	return $surgical_hospital_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'surgical_hospital_products_args' );

function surgical_hospital_products_args( $surgical_hospital_args ) {

    $surgical_hospital_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $surgical_hospital_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $surgical_hospital_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function surgical_hospital_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --surgical_hospital_logo_width: <?php echo absint(get_theme_mod('surgical_hospital_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('surgical_hospital_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'surgical_hospital_custom_css' );

function surgical_hospital_sanitize_choices( $surgical_hospital_input, $surgical_hospital_setting ) {
    global $wp_customize; 
    $surgical_hospital_control = $wp_customize->get_control( $surgical_hospital_setting->id ); 
    if ( array_key_exists( $surgical_hospital_input, $surgical_hospital_control->choices ) ) {
        return $surgical_hospital_input;
    } else {
        return $surgical_hospital_setting->default;
    }
}

function surgical_hospital_sanitize_phone_number( $surgical_hospital_phone ) {
	return preg_replace( '/[^\d+]/', '', $surgical_hospital_phone );
}

//Excerpt 
function surgical_hospital_excerpt_function($surgical_hospital_excerpt_count = 35) {
    $surgical_hospital_excerpt = get_the_excerpt();
    $surgical_hospital_text_excerpt = wp_strip_all_tags($surgical_hospital_excerpt);
    $surgical_hospital_excerpt_limit = (int) get_theme_mod('surgical_hospital_excerpt_limit', $surgical_hospital_excerpt_count);
    $surgical_hospital_words = preg_split('/\s+/', $surgical_hospital_text_excerpt); 
    $surgical_hospital_trimmed_words = array_slice($surgical_hospital_words, 0, $surgical_hospital_excerpt_limit);
    $surgical_hospital_theme_excerpt = implode(' ', $surgical_hospital_trimmed_words);

    return $surgical_hospital_theme_excerpt;
}


// Add admin notice
function surgical_hospital_admin_notice() { 
    global $pagenow;
    $surgical_hospital_theme_args      = wp_get_theme();
    $surgical_hospital_meta            = get_option( 'surgical_hospital_admin_notice' );
    $name            = $surgical_hospital_theme_args->__get( 'Name' );
    $surgical_hospital_current_screen  = get_current_screen();

    if( !$surgical_hospital_meta ){
        if( is_network_admin() ){
            return;
        }

        if( ! current_user_can( 'manage_options' ) ){
            return;
        } 
        
        if( $surgical_hospital_current_screen->base !== 'appearance_page_surgical_hospital_guide' && 
            $surgical_hospital_current_screen->base !== 'toplevel_page_surgicalhospital-demoimport' ) { ?>

            <div class="notice notice-success surgical-hospital-welcome-notice">
                <p class="surgical-hospital-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'surgical_hospital_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'surgical-hospital' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="surgical-hospital-welcome-notice-wrap">
                    <h2 class="surgical-hospital-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $surgical_hospital_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'surgical-hospital' ), $surgical_hospital_theme_name ) );
                        ?>
                    </h2>
                    <p class="surgical-hospital-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'surgical-hospital' ); ?>
                    </p>

                    <div class="surgical-hospital-welcome-info">
                        <div class="surgical-hospital-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'surgical-hospital' ); ?>">
                        </div>

                        <div class="surgical-hospital-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'surgical-hospital' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'surgical-hospital' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=surgicalhospital-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'surgical-hospital' ); ?></a></p>
                        </div>

                        <div class="surgical-hospital-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'surgical-hospital' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'surgical-hospital' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=surgical-hospital-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'surgical-hospital' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

    }
}

add_action( 'admin_notices', 'surgical_hospital_admin_notice' );

if( ! function_exists( 'surgical_hospital_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function surgical_hospital_update_admin_notice(){
    if ( isset( $_GET['surgical_hospital_admin_notice'] ) && $_GET['surgical_hospital_admin_notice'] = '1' ) {
        update_option( 'surgical_hospital_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'surgical_hospital_update_admin_notice' );

add_action('after_switch_theme', 'surgical_hospital_setup_options');
function surgical_hospital_setup_options () {
    update_option('surgical_hospital_admin_notice', FALSE );
}

// changelog
function surgical_hospital_get_changelog_from_readme() {
    $file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($file_path)) {
        $content = file_get_contents($file_path);

        // Extract changelog section
        $changelog_start = strpos($content, "== Changelog ==");
        $changelog = substr($content, $changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $changelog, $matches, PREG_SET_ORDER);
        
        return $matches;
    }
    return [];
}